const item = document.querySelector('.item'),
    MIN_WIDTH = 200,
    MIN_HEIGHT = 200,
    MAX_WIDTH = 500,
    MAX_HEIGHT = Infinity;

let isResizing = false

item.addEventListener('mousedown', mousedown);

function mousedown(e) {
    
    if(e.target !== e.currentTarget) return;
    
    window.addEventListener('mousemove', mousemove);
    window.addEventListener('mouseup', mouseup);
    
    let prevX = e.clientX;
    let prevY = e.clientY;
    
    const itemBCR = item.getBoundingClientRect();
    
    function mousemove(e) {
    if (!isResizing) {
      let newX = prevX - e.clientX;
      let newY = prevY - e.clientY;
    
      let x = itemBCR.left - newX
      let y = itemBCR.top - newY
    
      if (x < 0) x = 0
      if (x > window.innerWidth - itemBCR.width) x = window.innerWidth - itemBCR.width
    
      if (y < 0) y = 0
      if (y > window.innerHeight - itemBCR.height) y = window.innerHeight - itemBCR.height
    
      item.style.left = x + 'px';
      item.style.top = y + 'px';
    }
    }
    
    function mouseup() {
    window.removeEventListener('mousemove', mousemove);
    window.removeEventListener('mouseup', mouseup);
    }
}
